module Partoche.Partitions.Heiland where

import Euterpea


{- |
Christman song "O Heiland, reiß die Himmel auf"
from "Du wurdest meine Sonne - Heft I:
Advents- und Weihnachtslieder in einfachen Sätzen"
Evangelische Verlagsanstalt Berlin

Source : Haskore examples
-}

melody0 o =
   d o qn :+:
   (d o hn :=: f o hn) :+:
   (e o qn :=: g o qn) :+:
   ((f o qn :+: e o qn) :=: a o hn) :+:
   d o qn :+:
   (d o hn :+: cs o qn :=: f o qn :+: e o hn) :+:
   d o dhn

bass0 o = [d  (o+1) qn, d  (o+1) qn, c  (o+1) qn, bf o qn,
    a o hn, bf o qn, bf o qn, g  o qn, a  o qn,
    d o qn, a  o qn, d  (o+1) qn]

melody1 o =
   (f o qn :=: a o qn) :+:
   (e o qn :=: a o qn) :+:
   (d o qn :=: b o qn) :+:
   ((c o qn :+: d o qn) :=: c (o+1) hn) :+:
   f o qn :+:
   (f o hn :+: e o qn :=: a o qn :+: g o hn) :+:
   f o dhn

bass1 o =
   [d  (o+1) qn, c  (o+1) qn, b  o qn,
    a  o hn, d  (o+1) qn, d  (o+1) qn, bf o qn, c  (o+1) qn,
    f  o qn, c  (o+1) qn, f  (o+1) qn]

melody2 o =
   (g o hn :=: c (o+1) qn :+: c (o+1) qn) :+:
   (f o qn :=: c (o+1) qn) :+:
   (e o qn :+: g o qn :=: c (o+1) hn) :+:
   a o qn :+:
   (a o qn :+: g o qn :=: d (o+1) hn) :+:
   (f o qn :=: d (o+1) qn) :+:
   (f o qn :+: d o qn :+: e o qn :=: c (o+1) qn)

bass2 o =
   [f  (o+1)  qn, e  (o+1) qn, d  (o+1) qn, c  (o+1) qn, e  (o+1) qn, f  (o+1) qn,
    bf o dhn, c  (o+1) qn, g  o qn, c  o qn]

melody3 o =
   (f o qn :=: a o qn) :+:
   (e o qn :=: a o qn) :+:
   (d o qn :=: g o qn) :+:
   (d o qn :+: cs o qn :=: a o hn) :+:
   (d o qn :=: f o qn) :+:
   (d o hn :+: cs o qn :=: g o qn :+: e o hn) :+:
   d o qn

bass3 o =
   [d  o hn, e  o qn, a  o hn, bf o qn,
    bf o qn, g  o qn, a  o qn, d  o hn]


melody o = melody0 o :+: melody1 o :+: melody2 o :+: melody3 o

bass o = line (bass0 o) :+: line (bass1 o) :+: line (bass2 o) :+: line (bass3 o)

heiland o = tempo 1.5 $ melody o :=: bass o



